﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=10
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
	Public X_Per As Double = 1
	Public Y_Per As Double = 1	'коэффициэнты коррекции положения курсора2

End Sub

Sub Folder As String
	#if B4J
	Dim res As String = File.DirData(Main.appname)
	#else if B4A
	Dim res As String = DBUtils.GetDBFolder
	#end if
	Return res
End Sub

Sub Get_Stamp(moment As Long) As String
	Dim b As String, d, E As Long, f As Float
	Dim prevDateF As String = DateTime.DateFormat
	Dim prevTimeF As String = DateTime.TimeFormat
	DateTime.DateFormat = "yyyy-MM-dd"
	DateTime.TimeFormat = "HH-mm-ss"
	If moment = 0 Then
		d = DateTime.Now
	Else
		d = moment
	End If
	E = d - DateTime.TimeParse(DateTime.Time(d))
	f = E/DateTime.TicksPerSecond
	b = NumberFormat2(f, 0, 3, 3, False)

	Dim stamp As String = DateTime.DAte(d) & "_" & DateTime.Time(d) & b
	
	DateTime.DateFormat = prevDateF
	DateTime.TimeFormat = prevTimeF
	Return stamp
End Sub

Sub TicksToTime (t As Long, milliseconds As Boolean) As String
	Dim hours As Int = t / 1000 / 60 / 60
	Dim mins As Int = ((t / 1000) - (hours * 60 * 60)) / 60
	Dim secs As Int = ((t / 1000) - (hours * 60 * 60) - (mins * 60))
	Dim msecs As Float = ((t / 1000) - (hours * 60 * 60) - (mins * 60) - secs) * 1000
	Dim res As String = NumberFormat2(hours, 2, 0, 0, False) & ":" & NumberFormat2(mins, 2, 0, 0, False) & ":" & NumberFormat2(secs, 2, 0, 0, False)
	If milliseconds Then
		res = res & "." & NumberFormat2(msecs, 3, 0, 0, False)
	End If
	Return res
End Sub

#if B4J
	Sub RedirectOutput (Dir As String, FileName As String)
	   #if RELEASE
	   Dim out As OutputStream = File.OpenOutput(Dir, FileName, False) 'Set to True to append the logs
	   Dim ps As JavaObject
	   ps.InitializeNewInstance("java.io.PrintStream", Array(out, True, "utf8"))
	   Dim jo As JavaObject
	   jo.InitializeStatic("java.lang.System")
	   jo.RunMethod("setOut", Array(ps))
	   jo.RunMethod("setErr", Array(ps))
	   #end if
	End Sub

	Sub FullScreen(Frm As Form)
		Dim joForm As JavaObject = Frm
		Dim joStage As JavaObject = joForm.GetField("stage")
	joStage.RunMethod("setMaximized", Array(True))
End Sub
	

#end if

Sub get_ver As String
	#if B4J
	Return Main.ver
	#else
	Return Application.VersionName
	#end if
End Sub

Sub OpenLink(url As String)
	#if B4J
	Main.fx.ShowExternalDocument(url)
	#else
	Dim p As PhoneIntents
	Dim inte As Intent = p.OpenBrowser(url)
	inte.WrapAsIntentChooser("")
	StartActivity (inte)
	#end if
End Sub

Sub ProcessCount(ExeNamePattern As String) As Int
	Dim Count As Int = 0
	#if B4J
		Dim Result As ShellSyncResult
		Dim sh As Shell
		sh.InitializeDoNotHandleQuotes("", "tasklist", Null)
		Result = sh.RunSynchronous(2000)
		If Result.Success = False Then Return Count
		Dim Match As Matcher  = Regex.Matcher2(ExeNamePattern, Regex.CASE_INSENSITIVE, Result.StdOut)
		Do While Match.Find
			Count = Count + 1
		Loop
	#end if
	Return Count
End Sub

Sub Save_General_Settings
	StateManager.SetSetting("X_Per", X_Per)
	StateManager.SetSetting("Y_Per", Y_Per)
'	StateManager.SetSetting("RefreshIndex", RefreshIndex)
'	StateManager.SetSetting("AutoRefresh", AutoRefresh)
'	StateManager.SetSetting("VisibleTime", VisibleTime)
	
	StateManager.SaveSettings
End Sub

Sub Load_General_Settings
	X_Per = StateManager.GetSetting2("X_Per", 1)
	Y_Per = StateManager.GetSetting2("Y_Per", 1)
'	TimerFormat = StateManager.GetSetting2("TimerFormat", 0)
'	RefreshIndex = StateManager.GetSetting2("RefreshIndex", 3)
'	Calc_Refresh(RefreshIndex)
'	AutoRefresh = StateManager.GetSetting2("AutoRefresh", False)
'	VisibleTime = StateManager.GetSetting2("VisibleTime", 60)
	Log("Loaded X_Per = " & X_Per)
	Log("Loaded Y_Per = " & Y_Per)
End Sub

Sub Toast(text As String)
'	If text.Length > 100 Then
'		text = text.SubString2(0, 100)
'		Toast("Смотрите полный текст сообщения в логе")
'		Return
'	End If
'	#if B4J
'	Main.toast.Show(text)
'	#else
'	ToastMessageShow(text, False)
'	#end if
End Sub

Sub isSync As Boolean
'	If B4XPages.MainPage.SyncPage.Root.IsInitialized = False Then
'		Return False
'	Else
'		If B4XPages.MainPage.SyncPage.Root.Visible Then
'			Return True
'		Else
'			Return False
'		End If
'	End If
Return False
End Sub

